#include <bits/stdc++.h>
using namespace std;

void bfs(vector<vector<int> >& g, vector<bool>& vis, vector<int>& dist, int p, int h, int& col) 
{
    queue<int> q;
    dist[p] = 0;
    q.push(p);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (h == dist[v]) {
            if (!vis[v]) ++col;
            vis[v] = true;
            continue;
        }
        if (!vis[v]) ++col;
        vis[v] = true;
        for (auto& x : g[v]) {
            if (dist[x] > dist[v] + 1) {
                dist[x] = dist[v] + 1;
                q.push(x);
            }
        }
    }

}

void solve() 
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int> > g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> dist(g.size(), 1e9);
    vector<bool> vis(n, false);
    int col = 0;
    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;
        --p;
        bfs(g, vis, dist, p, h, col);
    }
    cout << col << endl;
    for (int i = 0; i < n; ++i) {
        if (vis[i])
            cout << i+1 << " ";
    }
    cout << endl;
}

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    //system("pause");
    return 0;
}